<?php
/**
 * Element: Categories
 * Displays a selectbox of available categories
 *
 * @package    FrontpagePlus
 * @version    0.1.0
 * @since      File available since Release 0.1.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl/frontpageplus
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Categories Element
 */
class JElementCategories extends JElement
{
	/*
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'Categories';

	function fetchElement( $name, $value, &$node, $control_name )
	{
		$_db = &JFactory::getDBO();

		$_query = 'SELECT c.id, c.title AS ctitle, s.title as stitle' .
			' FROM #__categories AS c' .
			' LEFT JOIN #__sections AS s ON s.id=c.section' .
			' WHERE c.published = 1' .
			' AND s.scope = "content"'.
			' ORDER BY s.ordering, c.ordering';

		$_db->setQuery( $_query );
		$_options = $_db->loadObjectList();
		for ( $i=0; $i<count( $_options ); $i++ ) 
		{
			$_stitle = explode( "\n",wordwrap( $_options[$i]->stitle, 48, "\n" ) );
			$_stitle = $_stitle['0'];
			$_stitle = ( $_stitle != $_options[$i]->stitle ) ? $_stitle.'...' : $_stitle;
			$_ctitle = explode( "\n",wordwrap( $_options[$i]->ctitle, 48, "\n" ) );
			$_ctitle = $_ctitle['0'];
			$_ctitle = ( $_ctitle != $_options[$i]->ctitle ) ? $_ctitle.'...' : $_ctitle;
			$_options[$i]->title = $_stitle.' / '.$_ctitle;
		}

		array_unshift( $_options, JHTML::_( 'select.option', '0', JText::_( 'Uncategorized' ), 'id', 'title' ) );
		array_unshift( $_options, JHTML::_( 'select.option', '-1', '- '.JText::_( 'All categories' ).' -', 'id', 'title' ) );

		return JHTML::_( 'select.genericlist',  $_options, ''.$control_name.'['.$name.'][]', 'multiple="multiple" size="8" class="inputbox"', 'id', 'title', $value, $control_name.$name  );
	}
}