<?php
/**
 * Element: Sections
 * Displays a selectbox of available sections
 *
 * @package    FrontpagePlus
 * @version    0.1.0
 * @since      File available since Release 0.1.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl/frontpageplus
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Sections Element
 */
class JElementSections extends JElement
{
	/*
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	var	$_name = 'Sections';

	function fetchElement( $name, $value, &$node, $control_name )
	{
		$_db =& JFactory::getDBO();

		$_query = 'SELECT id, title FROM #__sections WHERE published = 1 AND scope = "content" ORDER BY ordering';
		$_db->setQuery( $_query );
		$_options = $_db->loadObjectList();		
		for ( $i=0; $i<count( $_options ); $i++ ) {
			$_title = explode( "\n",wordwrap( $_options[$i]->title, 86, "\n" ) );;
			$_title = $_title['0'];
			$_title = ( $_title != $_options[$i]->title ) ? $_title.'...' : $_title;
			$_options[$i]->title = $_title;
		}

		array_unshift( $_options, JHTML::_( 'select.option', '0', JText::_( 'Uncategorized' ), 'id', 'title' ) );
		array_unshift( $_options, JHTML::_( 'select.option', '-1', '- '.JText::_( 'All sections' ).' -', 'id', 'title' ) );

		return JHTML::_( 'select.genericlist',  $_options, ''.$control_name.'['.$name.'][]', 'multiple="multiple" size="8" class="inputbox"', 'id', 'title', $value, $control_name.$name );
	}
}