<?php
/**
 * Model
 *
 * @package    FrontpagePlus
 * @version    0.1.0
 * @since      File available since Release 0.1.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl/frontpageplus
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once( JPATH_COMPONENT.DS.'models'.DS.'frontpage.php' );
		
/**
 * FrontpagePlus Component Model
 */
class ContentModelFrontpagePlus extends ContentModelFrontpage
{
	function _buildContentWhere()
	{
		global $mainframe;

		$user		=& JFactory::getUser();
		$gid		= $user->get( 'aid', 0 );
		// TODO: Should we be using requestTime here? or is JDate ok?
		// $now		= $mainframe->get( 'requestTime' );

		$jnow		=& JFactory::getDate();
		$now		= $jnow->toMySQL();

		// Get the page/component configuration
		$params = &$mainframe->getParams();

		$noauth		= !$params->get( 'show_noauth' );
		$nullDate	= $this->_db->getNullDate();

		//First thing we need to do is assert that the articles are in the current category
		$where = ' WHERE 1';

		// Does the user have access to view the items?
		if ( $noauth ) {
			$where .= ' AND a.access <= '.(int) $gid;
		}

		if ( $user->authorize( 'com_content', 'edit', 'content', 'all' )) {
			$where .= ' AND a.state >= 0';
		} else {
			$where .= ' AND a.state = 1'.
					' AND ( ( cc.published = 1'.
					' AND s.published = 1 )'.
					' OR ( a.catid = 0 AND a.sectionid = 0 ) )';

			$where .= ' AND ( a.publish_up = '.$this->_db->Quote( $nullDate ).' OR a.publish_up <= '.$this->_db->Quote( $now ).' )' .
					  ' AND ( a.publish_down = '.$this->_db->Quote( $nullDate ).' OR a.publish_down >= '.$this->_db->Quote( $now ).' )';
		}
		
		//////////////////////////////////////////////////////////////
		// This adds the ability to filter the frontpage articles
		// to certain sections and categories
		//////////////////////////////////////////////////////////////
		$sections = $params->get( 'sections' );
		if ( is_array( $sections ) ) { $sections = implode( ',',$sections ); }
		if ( $sections && $sections != '-1' ) { $where .= ' AND a.sectionid IN ( '.$sections.' )'; }
		$categories = $params->get( 'categories' );
		if ( is_array( $categories ) ) { $categories = implode( ',',$categories ); }
		if ( $categories && $categories != '-1' ) { $where .= ' AND a.catid IN ( '.$categories.' )'; }
		//////////////////////////////////////////////////////////////

		return $where;
	}
}
