<?php
/**
 * View: feed
 *
 * @package    FrontpagePlus
 * @version    0.1.0
 * @since      File available since Release 0.1.0
 *
 * @author     Peter van Westen <peter@nonumber.nl>
 * @link       http://www.nonumber.nl/frontpageplus
 * @copyright  Copyright (C) 2009 NoNumber! All Rights Reserved
 * @license    http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

/**
 * FrontpagePlus View class
 */
class ContentViewFrontpagePlus extends JView
{
	function display( $tpl = null )
	{
		global $mainframe;

		// parameters
		$db			=& JFactory::getDBO();
		$document	=& JFactory::getDocument();
		$params =& $mainframe->getParams();
		$document->link = JRoute::_( 'index.php?option=com_content&view=frontpageplus' );

		// Get some data from the model
		JRequest::setVar( 'limit', $mainframe->getCfg( 'feed_limit' ) );
		$rows 		= & $this->get( 'Data' );
		foreach ( $rows as $row )
		{
			// strip html from feed item title
			$title = $this->escape( $row->title );
			$title = html_entity_decode( $title );

			// url link to article
			$link = JRoute::_(ContentHelperRoute::getArticleRoute( $row->slug, $row->catslug, $row->sectionid ) );

			// strip html from feed item description text
			$description	= ( $params->get( 'feed_summary', 0 ) ? $row->introtext.$row->fulltext : $row->introtext );
			$author			= $row->created_by_alias ? $row->created_by_alias : $row->author;
						
			// load individual item creator class
			$item = new JFeedItem();
			$item->title 		= $title;
			$item->link 		= $link;
			$item->description 	= $description;
			$item->date			= $row->created;
			$item->category   	= 'frontpageplus';

			// loads item info into rss array
			$document->addItem( $item );
		}
	}
}
?>
